package de.intevation.flys.artifacts.datacage.templating;

import java.io.Serializable;

import java.sql.ResultSetMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.List;
import java.util.ArrayList;

public class ResultData
implements   Serializable
{
    protected String [] columns;

    protected List<Object []> rows;

    public ResultData() {
        rows = new ArrayList<Object []>();
    }

    public ResultData(ResultSetMetaData meta)
    throws SQLException
    {
        this();

        int N = meta.getColumnCount();

        columns = new String[N];

        for (int i = 1; i <= N; ++i) {
            columns[i-1] = meta.getColumnLabel(i);
        }
    }

    public String [] getColumnLabels() {
        return columns;
    }

    public ResultData addAll(ResultSet result) throws SQLException {
        while (result.next()) {
            add(result);
        }
        return this;
    }

    public void add(ResultSet result) throws SQLException {
        Object [] row = new Object[columns.length];
        for (int i = 0; i < columns.length; ++i) {
            row[i] = result.getObject(i+1);
        }
        rows.add(row);
    }

    public List<Object []> getRows() {
        return rows;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
